package com.s3ai.services;

import com.s3ai.dao.DAO;
import com.s3ai.entities.Cinema;
import com.s3ai.entities.Ticket;
import com.s3ai.entities.User;

import java.util.List;
import java.util.UUID;

public class TicketService {
    private static TicketService ticketService;
    private DAO dao;

    private TicketService() {
        this.dao = DAO.getInstance();
    }

    public static TicketService getInstance() {
        if (ticketService == null) {
            ticketService = new TicketService();
        }
        return ticketService;
    }

    public List<Ticket> getAllTickets() {
        return dao.getAllTickets();
    }

    public Ticket getTicketById(UUID id) {
        return dao.getTicketById(id);
    }

    public void saveTicket(Ticket ticket) {
        dao.saveEntity(ticket);
    }

    public void updateTicket(Ticket ticket) {
        dao.updateEntity(ticket);
    }

    public void deleteTicket(Ticket ticket) {
        dao.deleteEntity(ticket);
    }

    public void fillTicketFields(Ticket ticket, User user, Cinema cinema, String movie) {
        ticket.setUser(user);
        ticket.setCinema(cinema);
        ticket.setMovie(movie);
    }
}
